#include <stdio.h>
#include <stdlib.h>
#include <string.h>

//definizione del nuovo tipo sottorecord utente DettagliLibro
typedef struct
   		  {
			  char Isbn[10+1];
			  char Titolo[100+1];
			  char Autore [50+1];
			  char CasaEditrice[50+1];
			  } DettagliLibro;

//definizione del nuovo tipo record utente Libro
typedef struct
   		  {
			  DettagliLibro Detlib;
			  float Prezzo;
			  int Pagine;	
			  } Libro;

int main(int argc, char *argv[]) 
{
//Dichiarazione di una variabile record di tipo Libro
Libro lib;

// leggo la variabile record lib di tipo Libro campo x campo effettuando tutti i controlli
// N.B. la LETTURA o CARICAMENTO  un'operazione NON ATOMICA
printf("************* Lettura dati del record ***************\n");
// Isbn
do
   {
   printf("Inserisci Isbn: ");
	gets(lib.Detlib.Isbn);
	}
while ((strlen(lib.Detlib.Isbn) == 0) || (strlen(lib.Detlib.Isbn) > 10));	

// Titolo
do
   {
   printf("Inserisci Titolo: ");
	gets(lib.Detlib.Titolo);
	}
while ((strlen(lib.Detlib.Titolo) == 0) || (strlen(lib.Detlib.Titolo) > 100));	
 
// Autore
do
   {
   printf("Inserisci Autore: ");
	gets(lib.Detlib.Autore);
	}
while ((strlen(lib.Detlib.Autore) == 0) || (strlen(lib.Detlib.Autore) > 50));

// CasaEditrice
do
   {
   printf("Inserisci Casa Editrice: ");
	gets(lib.Detlib.CasaEditrice);
	}
while ((strlen(lib.Detlib.CasaEditrice) == 0) || (strlen(lib.Detlib.CasaEditrice) > 50));

// Prezzo
do
   {
   printf("Inserisci Prezzo: ");
	scanf("%f", &(lib.Prezzo));	
	}
while ((lib.Prezzo <= 0) || (lib.Prezzo > 999.99)); 
 
// Pagine
do
   {
   printf("Inserisci pagine: ");
	scanf("%d", &(lib.Pagine));	
	}
while ((lib.Pagine <= 0) || (lib.Pagine > 9999)); 
 
// Scrivo la variabile record lib di tipo Libro campo x campo
// N.B. la SCRITTURA o VISUALIZZAZIONE  un'operazione NON ATOMICA
printf("************* Scrittura dati del record ***************\n");
printf("Isbn: %s\n", lib.Detlib.Isbn);
printf("Titolo: %s\n", lib.Detlib.Titolo);
printf("Autore: %s\n", lib.Detlib.Autore);
printf("Casa Editrice: %s\n",lib.Detlib.CasaEditrice);
printf("Prezzo: %.2f\n",lib.Prezzo);
printf("Pagine: %d\n\n", lib.Pagine);

return 0;
}
